%define		pname apf
%define		pversion 1.7.6
%define         bundleversion 3
%define 	bversion 23
%define		rpmrelease 1.iworx

%define		basedir /etc/apf
%define		binpath /usr/local/sbin/apf
%define		compat_binpath /usr/local/sbin/fwmgr

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define		build_unk      1

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		release %{bundleversion}.%{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	APF - Advanced Policy Firewall
Name:		%{pname}
Version:	%{pversion}
Release: 	%{release}
License:	GPL

Group:		System Environment/Daemons
Source0:	%{name}-%{pversion}-%{bundleversion}.tar.gz
URL:		http://www.rfxnetworks.com/apf.php

Distribution:	InterWorx
Vendor:         INTERWORX L.L.C.
Packager:       Tim College <tcollege@interworx.com>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

BuildArch:	noarch

Epoch:		4

Requires:	    grep
Requires:	    sed
Requires:	    net-tools
Requires:	    coreutils
Requires:	    iptables
#Requires(post): /sbin/ifconfig

Source1:	conf.apf
Patch0:		apf-9.7-0.9.5-compat.patch
Patch1:		apf.init-status.patch
Patch2:         apf-iface_in-import.patch

%description
APF is a policy based iptables firewall system designed for ease 
of use and configuration. It employs a subset of features to satisfy
the veteran Linux user and the novice alike. Packaged in tar.gz format 
and RPM formats, make APF ideal for deployment in many server 
environments based on Linux.

%prep

[ -n %{buildroot} ] && rm -rf %{buildroot}

[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%setup -q -n %{name}-%{version}-%{bundleversion}

%patch0 -p1
%patch1 -p2
%patch2 -p1

# Display compilation flags and OS with colors ;)

[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# compilation Exports
export CC="gcc %{ccflags}"
export CFLAGS="%{ccflags}"
export LDFLAGS="%{ldflags}"

%build

%install

##
INSTALL_PATH="%{buildroot}%{basedir}"
BINPATH="%{binpath}"
COMPAT_BINPATH="%{compat_binpath}"

mkdir -p $INSTALL_PATH
rm -f files/conf.apf
cp -fR files/* $INSTALL_PATH

cp -pf .ca.def importconf $INSTALL_PATH/extras/
mkdir -p $INSTALL_PATH/doc
cp README CHANGELOG COPYING.GPL $INSTALL_PATH/doc

#mkdir -p %{buildroot}%{_sysconfdir}/cron.daily
mkdir -p %{buildroot}%{_sysconfdir}/init.d
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d

#install -m 0700 cron.daily 	%{buildroot}%{_sysconfdir}/cron.daily/apf
install -m 0700 apf.init 	%{buildroot}%{_sysconfdir}/init.d/apf
install -m 0600 logrotate.d.apf %{buildroot}%{_sysconfdir}/logrotate.d/apf

chmod 750 $INSTALL_PATH/apf
chmod 750 $INSTALL_PATH/firewall
chmod 750 $INSTALL_PATH/vnet/vnetgen
chmod 750 $INSTALL_PATH/extras/get_ports
chmod 750 $INSTALL_PATH

install -m 0640 %{SOURCE1} %{buildroot}%{basedir}

%post

# make symlinks
ln -fs %{basedir}/apf %{binpath}
ln -fs %{basedir}/apf %{compat_binpath}

cp -f %{basedir}/conf.apf %{basedir}/conf.apf.backup

# make sure we do the right think on VPS systems
if [ `ifconfig | egrep -c "venet0"` -gt 0 ]; then
	/bin/sed -i -r "s/IFACE_IN=\"eth0\"/IFACE_IN=\"venet0\"/" %{basedir}/conf.apf
	/bin/sed -i -r "s/IFACE_OUT=\"eth0\"/IFACE_OUT=\"venet0\"/" %{basedir}/conf.apf
	/bin/sed -i -r "s/SET_MONOKERN=\"0\"/SET_MONOKERN=\"1\"/" %{basedir}/conf.apf
fi

if [ "$1" == "1" ]; then
    modprobe ip_tables > /dev/null 2>&1 || :
    if [ $(lsmod | grep ip_tables | wc -l ) -eq 0 ]; then
        /bin/sed -i -r "s/SET_MONOKERN=\"0\"/SET_MONOKERN=\"1\"/" %{basedir}/conf.apf || :
    fi
fi

# try to better guess a default interface than necessarily eth0
if [ $1 -eq 1 ]; then
    IFACE_UNTRUSTED=$(ifconfig -a | sed 's/[ \t].*//;/^\(lo\|\)$/d' | grep -v : | head -1)
    /bin/sed -i "s/^IFACE_UNTRUSTED.*/IFACE_UNTRUSTED=\"$IFACE_UNTRUSTED\"/g" %{basedir}/conf.apf > /dev/null 2>&1 || :
fi

# delete old crap
rm -f /etc/cron.d/fwdev
rm -f %{basedir}/cron.fwdev
if [ -f "/etc/cron.hourly/fw" ]; then
	rm -f /etc/cron.hourly/fw
fi
if [ -f "/etc/cron.daily/fw" ]; then
	rm -f /etc/cron.daily/fw
fi

if [ -f "/var/log/apf_log" ] || [ -f "/var/log/apfados_log" ]; then
	rm -f /var/log/apf_log /var/log/apfados_log
fi

if [ $1 = 1 ] ; then
	if [ -f "/sbin/chkconfig" ]; then
		/sbin/chkconfig --add apf
		/sbin/chkconfig --level 345 apf off
	fi
fi

# run conf importer
cd %{basedir}/extras
./importconf

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
rm -rf $RPM_BUILD_DIR/%{name}-%{pversion} || :

%pre

if [ $1 -gt 1 ] ; then 
	INSTALL_PATH="%{basedir}"
	cd $INSTALL_PATH
	VER=`echo 'version: %{pversion}-{%bversion}' | grep version | awk '{print$2}'`
	if [ -d "$INSTALL_PATH" ]; then
		DVAL=`date +"%d%m%Y-%s"`
		cp -R $INSTALL_PATH $INSTALL_PATH.bk$DVAL
		rm -f %{basedir}.bk.last
		ln -fs $INSTALL_PATH.bk$DVAL %{basedir}.bk.last 
#		rm -rf $INSTALL_PATH
	fi
fi


%postun

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: apf package removal request denied.  This package is required by interworx."
   echo
   exit 1
fi

%files
%defattr(-,root,root)
%attr(0750,root,root) %dir %{basedir}
%attr(-,root,root) %{basedir}/doc
%attr(-,root,root) %{basedir}/extras
%attr(-,root,root) %{basedir}/internals
%attr(-,root,root) %{basedir}/vnet
%attr(-,root,root) %{basedir}/VERSION
%attr(-,root,root) %{basedir}/apf
%attr(-,root,root) %{basedir}/firewall
%attr(0700,root,root) %{_sysconfdir}/init.d/apf
%attr(0600,root,root) %{_sysconfdir}/logrotate.d/apf
%config %{basedir}/conf.apf
%config(noreplace) %{basedir}/*.rules

#%attr(0700,root,root) %{_sysconfdir}/cron.daily/apf

%changelog
* Mon Dec 20 2021 Joseph Purkis <jpurkis@interworx.com>
- Remove ancient dynamic gcc resolution (always resulted in just 'gcc')
- Almalinux update
* Tue May 25 2021 Tim College <tcollege@interworx.com>
- Upgrade to 1.7.6-3 https://github.com/rfxn/advanced-policy-firewall/releases/tag/1.7.6-3
* Wed Nov 18 2020 Tim College <tcollege@interworx.com>
- Upgrade to 1.7.6-2 https://github.com/rfxn/advanced-policy-firewall/releases/tag/1.7.6-2
* Tue Jun 18 2019 Paul Oehler <poehler@interworx.com>
- Upgrade to 1.7.6-1 https://github.com/rfxn/advanced-policy-firewall/releases/tag/1.7.6-1
* Tue May 08 2018 Paul Oehler <poehler@interworx.com>
- Upgrade to https://github.com/rfxn/advanced-policy-firewall/commit/93adac0e19f8e486826dda4c2706dbf294b4b2b8
* Mon Sep 18 2017 Paul Oehler <poehler@interworx.com>
- Upgrade to https://github.com/rfxn/advanced-policy-firewall/releases/tag/1.7.5-2
* Tue Mar 15 2016 Matt Parmelee <mparmelee@interworx.com>
- Defaulted RESV_DNS to ON.
* Wed Mar 09 2016 Matt Parmelee <mparmelee@interworx.com>
- Implemented 'best guess' default interface
* Mon May 05 2014 Paul Oehler <poehler@interworx.com>
- patched hard coded eth0 in internals.conf
* Thu Feb 20 2014 Tim College <tcollege@interworx.com>
- Upgraded to APF 1.7.5
- Set Epoch to 4, because APF changed its name convention
* Wed Jun 15 2011 Paul Oehler <poehler@interworx.com>
- Set Epoch to 3, to combat incompatible updates from 3rd party repos.
- Added port 24 to default open ports, as sftp will be there by default.
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Wed Oct 19 2005 Chris Wells <clwells@nexcess.net>
- making work on vps systems
* Sat Oct 23 2004 Chris Wells <clwells@nexcess.net>
- initial release
